/* eeprom.c file

ܣ
FlashEEPROM ڱƫúͱ궨
------------------------------------
 */
#include "eeprom.h"

#define  PAGE_Gyro   (0x08000000 + 60 * 1024) //ǵƫôڵ60ҳFlash
#define  PAGE_Magic  (0x08000000 + 61 * 1024) //Ƶı궨ֵڵ61ҳFlash

/**************************ʵֺ********************************************
*ԭ:	   void Read_Gyro_Offset(int16_t *offset_gx,int16_t *offset_gy,int16_t *offset_gz)
*:	   ȡFlashеƫݡ
  ƫãָ
  
*******************************************************************************/
void Read_Gyro_Offset(int16_t *offset_gx,int16_t *offset_gy,int16_t *offset_gz)                                
{
	
    int16_t *temp_addr = (int16_t *)PAGE_Gyro;
	FLASH_Unlock();
	*offset_gx=*temp_addr;
	temp_addr++;
    *offset_gy=*temp_addr;
	temp_addr++;
    *offset_gz=*temp_addr; 
	FLASH_Lock();                                                                                            
}

/**************************ʵֺ********************************************
*ԭ:	   void Write_Gyro_Offset(int16_t offset_gx,int16_t offset_gy,int16_t offset_gz)
*:	   ƫôŵFlash
  ƫ
  
*******************************************************************************/
void Write_Gyro_Offset(int16_t offset_gx,int16_t offset_gy,int16_t offset_gz)
{
 	uint32_t temp_addr = PAGE_Gyro;
 	FLASH_Unlock();
 	FLASH_ErasePage(PAGE_Gyro); 

 	FLASH_ProgramHalfWord(temp_addr,offset_gx);
 	temp_addr+=2;

 	FLASH_ProgramHalfWord(temp_addr,offset_gy);
 	temp_addr+=2;

 	FLASH_ProgramHalfWord(temp_addr,offset_gz);
 	temp_addr+=2;

 	FLASH_Lock();    
}

/**************************ʵֺ********************************************
*ԭ:	   void Read_Magic_Offset(int16_t *min_mx,int16_t *min_my,int16_t *min_mz,
										int16_t *max_mx,int16_t *max_my,int16_t *max_mz)
*:	   FlashȡƱ궨
  ĶӦֵСֵ
  
*******************************************************************************/
void Read_Magic_Offset(int16_t *min_mx,int16_t *min_my,int16_t *min_mz,
int16_t *max_mx,int16_t *max_my,int16_t *max_mz)                                
{
	
    int16_t *temp_addr = (int16_t *)PAGE_Magic;
	FLASH_Unlock();
	*min_mx=*temp_addr;
	temp_addr++;
    *min_my=*temp_addr;
	temp_addr++;
    *min_mz=*temp_addr;   
	temp_addr++;

	*max_mx=*temp_addr;   
	temp_addr++;
	*max_my=*temp_addr;   
	temp_addr++;
	*max_mz=*temp_addr;  
	FLASH_Lock();                                                                
}

/**************************ʵֺ********************************************
*ԭ:	   void Write_Magic_Offset(int16_t min_mx,int16_t min_my,int16_t min_mz,
							int16_t max_mx,int16_t max_my,int16_t max_mz)
*:	   Ʊ궨дFlash
  ĶӦֵСֵ
  
*******************************************************************************/
void Write_Magic_Offset(int16_t min_mx,int16_t min_my,int16_t min_mz,
int16_t max_mx,int16_t max_my,int16_t max_mz)
{
 	uint32_t temp_addr = PAGE_Magic;
 	FLASH_Unlock();
 	FLASH_ErasePage(PAGE_Magic); 

 	FLASH_ProgramHalfWord(temp_addr,min_mx);
 	temp_addr+=2;

 	FLASH_ProgramHalfWord(temp_addr,min_my);
 	temp_addr+=2;

 	FLASH_ProgramHalfWord(temp_addr,min_mz);
 	temp_addr+=2;

 	FLASH_ProgramHalfWord(temp_addr,max_mx);
 	temp_addr+=2;

 	FLASH_ProgramHalfWord(temp_addr,max_my);
 	temp_addr+=2;

 	FLASH_ProgramHalfWord(temp_addr,max_mz);

 	FLASH_Lock();    
}

//------------------End of File----------------------------
