/* main.c file
ܣ
1.ʼ
2.̬͸߶Ȳ
3.̬͸ϴ MiniIMU AHRS 
4.Ӧ PC͵
------------------------------------
*/

#include "stm32f10x.h"
#include "LED.h"
#include "UARTs.h"
#include "UART2.h"
#include "IOI2C.h"
#include "delay.h"
#include "MPU6050.h"
#include "HMC5883L.h"
#include "BMP085.h"
#include "IMU.h"
#include "eeprom.h"

//ϴݵ״̬
#define REIMU  0x01 //ϴ̬
#define REMOV  0x02	//ϴ
#define REHMC  0x03	//ϴƵı궨ֵ

#define Upload_Speed  15   //ϴٶ  λ Hz
#define upload_time (1000000/Upload_Speed)/2  //ϴʱ䡣λΪus

int16_t ax, ay, az;	
int16_t gx, gy, gz;
int16_t hx, hy, hz;
int32_t Temperature = 0, Pressure = 0, Altitude = 0;
uint32_t system_micrsecond;
int16_t hmcvalue[3];
u8 state= REIMU;
/**************************ʵֺ********************************************
*ԭ:		int main(void)
*:		
*******************************************************************************/
int main(void)
{
	int16_t Math_hz=0;
	unsigned char PC_comm; //PC ؼֽ	 
	float ypr[3]; // yaw pitch roll
	/* ϵͳʱΪ72M ʹⲿ8M+PLL*/      
    SystemInit();
	delay_init(72);		//ʱʼ
    Initial_LED_GPIO();	//ʼSTM32-SDKϵLEDӿ
//	Initial_PWMLED();
	Initial_UART1(115200L);
	Initial_UART2(115200L);
	IIC_Init();	 //ʼI2Cӿ
	delay_ms(300);	//ȴϵ
	UART1_Put_String("Initialize...\r\n");
	IMU_init(); //ʼIMUʹ
	system_micrsecond=micros();
	GPIO_ResetBits(GPIOB, GPIO_Pin_0);
	while(1){	//ѭ
		
	//delay_ms(1); //ʱҪô졣
	IMU_getYawPitchRoll(ypr); //̬
	Math_hz++; // ++
	BMP085_Routing(); //BMP085 


//-------------λ------------------------------
	//Ƿ˸ λʱˣ
	if((micros()-system_micrsecond)>upload_time){
	switch(state){ 
	case REIMU:
	BMP085_getTemperat(&Temperature); //ȡ¶ֵ
	BMP085_getPress(&Pressure);	   //ȡѹֵ
	BMP085_getAlt(&Altitude);	   //ȡԸ߶
	//UART1_ReportIMU((int16_t)(ypr[0]*10.0),(int16_t)(ypr[1]*10.0),
	//(int16_t)(ypr[2]*10.0),Altitude/10,Temperature,Pressure/10,Math_hz*16);
	UART2_ReportIMU((int16_t)(ypr[0]*10.0),(int16_t)(ypr[1]*10.0),
	(int16_t)(ypr[2]*10.0),Altitude/10,Temperature,Pressure/10,Math_hz*Upload_Speed);
	Math_hz=0;
	state = REMOV; //״̬
	break;
	case REMOV:
	MPU6050_getlastMotion6(&ax, &ay, &az, &gx, &gy, &gz);
	HMC58X3_getlastValues(&hx,&hy,&hz);
	//UART1_ReportMotion(ax,ay,az,gx,gy,gz,hx,hy,hz);
	UART2_ReportMotion(ax,ay,az,gx,gy,gz,hx,hy,hz);
	state = REIMU;
	if(HMC5883_calib)state = REHMC; //Ҫ͵ǰƱ궨ֵ
	break;
	default: 
	UART2_ReportHMC(HMC5883_maxx,HMC5883_maxy,HMC5883_maxz,
		 HMC5883_minx,HMC5883_miny,HMC5883_minz,0);//ͱ궨ֵ
	state = REIMU;
	break;
	}//switch(state) 			 
	system_micrsecond=micros();	 //ȡϵͳʱ λ us 
//	LED_Change();	//LED1ı
	}
//--------------------------------------------------
	//PC
	if((PC_comm=UART2_CommandRoute())!=0xff)
	{
	switch(PC_comm){ //ʶ
	case Gyro_init:			MPU6050_InitGyro_Offset(); break; //ȡƫ
    case HMC_calib:			HMC5883L_Save_Calib();	break;   //Ʊ궨
	case High_init:			BMP085_ResetAlt(0); 	break;		//ѹ߶ 
	case HMC_calib_begin:	HMC5883L_Start_Calib();	break; //ʼƱ궨
	}
	}// PC ͵

	}//ѭ while(1) 

}  //main	

//------------------End of File----------------------------
